/*
 * First example of OpenCL program:
 * Show information about available devices.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <CL/cl.h>

#include "utility.h"

int main(int argc, char* argv[]) {

    cl_uint num_platforms = 0;
    platform_info_t * platform_info = NULL;

    platform_info = 
        getAllDeviceInfo(CL_DEVICE_TYPE_ALL, &num_platforms, CL_TRUE);
    if (platform_info == NULL) {
        exit(EXIT_FAILURE);
    }

    int main_rval = EXIT_SUCCESS;

    for (cl_uint i = 0; i < num_platforms; ++i) {
        fprintf(stdout, "Platform %d:\n", i);
        for (cl_uint j = 0; j < platform_info[i].num_devices; ++j) {
            fprintf(stdout, "Device %d:\n", j);
            cl_int rval = output_device_info(
                    stdout, platform_info[i].devices[j]);
            if (rval != CL_SUCCESS) main_rval = EXIT_FAILURE;
        }
    }

    freePlatformInfo(num_platforms, platform_info);
    return main_rval;
}
